blob: cdbf91107952a49cacc161b410820c50b34cb599 [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
24#ONLY TESTED for Ubuntu 14.10 14.04, CentOS7 and RHEL7
25#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
27# $1: database user
28# $2: database password
29
30function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020031 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020032 echo -e "Install last stable source code in ./openmano and the needed packages"
33 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020034 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020035 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
36 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
37 echo -e " -q --quiet: install in an unattended mode"
38 echo -e " -h --help: show this help"
39 echo -e " --develop: install last version for developers, and do not configure as a service"
garciadeblas16304ba2016-05-11 14:47:39 +020040}
41
42function install_packages(){
43 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020044 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020045
46 #check properly installed
47 for PACKAGE in $*
48 do
49 PACKAGE_INSTALLED="no"
50 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
51 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
52 if [ "$PACKAGE_INSTALLED" = "no" ]
53 then
tiernoc50e5da2016-07-06 17:49:45 +020054 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas16304ba2016-05-11 14:47:39 +020055 exit -1
56 fi
57 done
58}
59
tierno45a52852016-08-26 14:39:42 +020060GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
tiernoc50e5da2016-07-06 17:49:45 +020061DBUSER="root"
62DBPASSWD=""
63DBPASSWD_PARAM=""
64QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020065DEVELOP=""
tiernoc50e5da2016-07-06 17:49:45 +020066while getopts ":u:p:hiq-:" o; do
67 case "${o}" in
68 u)
69 export DBUSER="$OPTARG"
70 ;;
71 p)
72 export DBPASSWD="$OPTARG"
73 export DBPASSWD_PARAM="-p$OPTARG"
74 ;;
75 q)
76 export QUIET_MODE=yes
77 export DEBIAN_FRONTEND=noninteractive
78 ;;
79 h)
80 usage && exit 0
81 ;;
82 -)
83 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +020084 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
85 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tiernoc50e5da2016-07-06 17:49:45 +020086 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
87 exit 1
88 ;;
89 \?)
90 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
91 exit 1
92 ;;
93 :)
94 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
95 exit 1
96 ;;
97 *)
98 usage >&2
99 exit -1
100 ;;
101 esac
102done
garciadeblas16304ba2016-05-11 14:47:39 +0200103
tiernoc50e5da2016-07-06 17:49:45 +0200104#check root privileges and non a root user behind
105[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit -1
106if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
107then
108 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
109 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
110 export SUDO_USER=root
111fi
garciadeblas16304ba2016-05-11 14:47:39 +0200112
113#Discover Linux distribution
114#try redhat type
115[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
116#if not assuming ubuntu type
117[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
118if [ "$_DISTRO" == "Ubuntu" ]
119then
tierno45a52852016-08-26 14:39:42 +0200120 _RELEASE=$(lsb_release -rs)
121 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200122 then
tierno45a52852016-08-26 14:39:42 +0200123 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
tiernoc50e5da2016-07-06 17:49:45 +0200124 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200125 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200126 fi
127elif [ "$_DISTRO" == "CentOS" ]
128then
129 _RELEASE="7"
130 if ! cat /etc/redhat-release | grep -q "7."
131 then
tiernoc50e5da2016-07-06 17:49:45 +0200132 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
133 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200134 fi
135elif [ "$_DISTRO" == "Red" ]
136then
137 _RELEASE="7"
138 if ! cat /etc/redhat-release | grep -q "7."
139 then
tiernoc50e5da2016-07-06 17:49:45 +0200140 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
141 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200142 fi
143else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
144 _DISTRO_DISCOVER=$_DISTRO
145 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
146 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tiernoc50e5da2016-07-06 17:49:45 +0200147 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
148 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200149fi
150
151
152
153echo '
154#################################################################
155##### UPDATE REPOSITORIES #####
156#################################################################'
157[ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
158
159[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
160[ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
161[ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
162 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
163[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
164
165
166echo '
167#################################################################
168##### INSTALL REQUIRED PACKAGES #####
169#################################################################'
170[ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
171[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
172
tiernoc50e5da2016-07-06 17:49:45 +0200173if [[ "$_DISTRO" == "Ubuntu" ]]
174then
175 #start services. By default CentOS does not start services
176 service mysql start >> /dev/null
177 # try to set admin password, ignore if fails
178 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
179fi
180
garciadeblas16304ba2016-05-11 14:47:39 +0200181if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
182then
183 #start services. By default CentOS does not start services
184 service mariadb start
185 service httpd start
186 systemctl enable mariadb
187 systemctl enable httpd
188 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
189 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
190
191 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
192 [ "$KK" != "n" -a "$KK" != "no" ] &&
193 firewall-cmd --permanent --zone=public --add-service=http &&
194 firewall-cmd --permanent --zone=public --add-service=https &&
195 firewall-cmd --reload
196fi
197
198#check and ask for database user password. Must be done after database installation
tiernoc50e5da2016-07-06 17:49:45 +0200199if [[ -n $QUIET_MODE ]]
200then
201 echo -e "\nCheking database connection and ask for credentials"
202 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM ping
203 do
garciadeblas16304ba2016-05-11 14:47:39 +0200204 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
205 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
206 read -e -p "database user? ($DBUSER) " DBUSER_
207 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
208 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
tiernoc50e5da2016-07-06 17:49:45 +0200209 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
210 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
garciadeblas16304ba2016-05-11 14:47:39 +0200211 logintry="yes"
tiernoc50e5da2016-07-06 17:49:45 +0200212 done
213fi
garciadeblas16304ba2016-05-11 14:47:39 +0200214
215echo '
216#################################################################
217##### INSTALL PYTHON PACKAGES #####
218#################################################################'
tiernof97fd272016-07-11 14:32:37 +0200219[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils"
220[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils"
garciadeblas16304ba2016-05-11 14:47:39 +0200221
222#The only way to install python-bottle on Centos7 is with easy_install or pip
223[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
224
225#install openstack client needed for using openstack as a VIM
226[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient"
227[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient #TODO revise if gcc python-pip is needed
228
229echo '
230#################################################################
231##### DOWNLOAD SOURCE #####
232#################################################################'
tierno45a52852016-08-26 14:39:42 +0200233su $SUDO_USER -c 'git clone '"${GIT_URL}"' openmano'
234#[[ -z $DEVELOP ]] && su $SUDO_USER -c 'git checkout <tag version>'
garciadeblas16304ba2016-05-11 14:47:39 +0200235
236echo '
237#################################################################
238##### CREATE DATABASE #####
239#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200240mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200241
tiernoc50e5da2016-07-06 17:49:45 +0200242echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql -u$DBUSER $DBPASSWD_PARAM -s || ! echo "Failed while creating user mano at dabase" || exit 1
243echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql -u$DBUSER $DBPASSWD_PARAM -s || ! echo "Failed while creating user mano at dabase" || exit 1
244echo " Database 'mano_db' created, user 'mano' password 'manopw'"
garciadeblas16304ba2016-05-11 14:47:39 +0200245
tierno462e3882016-07-06 17:52:14 +0200246su $SUDO_USER -c 'openmano/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db' || ! echo "Failed while creating user mano at dabase" || exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200247
248if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
249then
250 echo '
251#################################################################
252##### CONFIGURE firewalld #####
253#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200254 KK=yes
255 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
garciadeblas16304ba2016-05-11 14:47:39 +0200256 if [ "$KK" != "n" -a "$KK" != "no" ]
257 then
258 #Creates a service file for openmano
259 echo '<?xml version="1.0" encoding="utf-8"?>
260<service>
261 <short>openmanod</short>
262 <description>openmanod service</description>
263 <port protocol="tcp" port="9090"/>
264</service>' > /etc/firewalld/services/openmanod.xml
265 #put proper permissions
266 pushd /etc/firewalld/services > /dev/null
267 restorecon openmanod.xml
268 chmod 640 openmanod.xml
269 popd > /dev/null
270 #Add the openmanod service to the default zone permanently and reload the firewall configuration
271 firewall-cmd --permanent --add-service=openmanod > /dev/null
272 firewall-cmd --reload > /dev/null
273 echo "done."
274 else
275 echo "skipping."
276 fi
277fi
278
279echo '
280#################################################################
281##### CONFIGURE OPENMANO CLIENT #####
282#################################################################'
283#creates a link at ~/bin
tiernoc50e5da2016-07-06 17:49:45 +0200284su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
285su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
286su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
287su $SUDO_USER -c 'ln -s ${PWD}/openmano/openmano ${HOME}/bin/openmano'
288su $SUDO_USER -c 'ln -s '${PWD}'/openmano/scripts/openmano-report.sh ${HOME}/bin/openmano-report'
289su $SUDO_USER -c 'ln -s '${PWD}'/openmano/scripts/service-openmano.sh ${HOME}/bin/service-openmano'
garciadeblas16304ba2016-05-11 14:47:39 +0200290
291#insert /home/<user>/bin in the PATH
292#skiped because normally this is done authomatically when ~/bin exist
tiernoc50e5da2016-07-06 17:49:45 +0200293#if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
garciadeblas16304ba2016-05-11 14:47:39 +0200294#then
295# echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200296# su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200297#fi
tiernoc50e5da2016-07-06 17:49:45 +0200298if [[ $SUDO_USER == root ]]
299then
300 if ! echo $PATH | grep -q "${HOME}/bin"
301 then
302 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
303 fi
304fi
garciadeblas16304ba2016-05-11 14:47:39 +0200305
306#configure arg-autocomplete for this user
307#in case of minimal instalation this package is not installed by default
308[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
309#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
310su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200311if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200312then
313 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200314 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200315fi
316
tierno45a52852016-08-26 14:39:42 +0200317
318
319
320if [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]]
321then
322echo '
323#################################################################
324##### CONFIGURE OPENMANO SERVICE #####
325#################################################################'
326
garciadeblas1ef7e522016-09-12 17:08:04 +0200327 ./openmano/scripts/install-openmano-service.sh -f openmano #-u $SUDO_USER
tierno45a52852016-08-26 14:39:42 +0200328# alias service-openmano="service openmano"
329# echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
330
331 echo
332 echo "Done! you may need to logout and login again for loading client configuration"
333 echo " Manage server with 'service openmano start|stop|status|...' "
334
335
336else
337
338 echo
339 echo "Done! you may need to logout and login again for loading client configuration"
340 echo " Run './openmano/scripts/service-openmano.sh start' for starting openmano in a screen"
341
342fi
garciadeblas16304ba2016-05-11 14:47:39 +0200343
344
345